#! /usr/bin/python

import numpy
import random

def mz(var):
    res = 0.0
    for i, x in enumerate(var):
        res += numpy.sin(x) * pow(numpy.sin(float(i * x * x) / numpy.pi), 20)
    return res

def djf1(var):
    res = 0.0
    for x in var:
        res += x * x
    return res

def djf2(var):
    [x1, x2] = var
    return 100.0 * (x2 * x2 - x1) + (1 - x1)

def djf3(var):
    res = 0
    for x in var:
        res += int(x)
    return res

# def gp(var):
#     [x1, x2] = var
#     return 100.0 * (x2 * x2 - x1) + (1 - x1)
# (1 + pow(x1 + x2 + 1, 2) * (19 - 14 * x1 + pow(13 * x1, 2) - 14 * x2 + 6 * x1* x2 + pow(3 * x2, 2)) .
# [30 + (2x1 - 3x2)2  (18 - 32x1 + 12x12 - 48x2 - 36x1x2 + 27x22]

random.seed()

def temperature(k):
    return 0.95 * k

def recuit(f, (min, max), dim):
    interval = max - min
    value = []
    temp = 20
    for i in xrange(dim):
        value.append(random.random() * interval + min)
    max_iter = 100000
    k = 0
    nb_swap = 0
    swap_condition1 = 100000
    swap_condition2 = interval
    min_glob = value
    while (k < max_iter):
        i = random.randint(0, dim - 1)
        neighbor = value
        neighbor[i] = random.random() * interval + min
        dt = f(neighbor) - f(value)

        if f(neighbor) < f(min_glob):
            min_glob = neighbor

        if nb_swap % swap_condition1 == 0 or nb_swap % swap_condition2 == 0:
            temp = temperature(temp)

        if (temp < 0.1):
            temp *= 1.5

        r = random.random()
        if r < numpy.exp(-float(dt) / temp):
            value = neighbor
            nb_swap += 1
        k += 1
    return min_glob, f(min_glob), temp, value, f(value)

if __name__ == "__main__":
    print recuit(djf1, (-5.12, 5.12), 2);
